#include "main.h"

/********************************************************************/
/***  Functions to compare newly generated trees to the k saved   ***/
/***  and determine whether the newly generated tree has already  ***/
/***  been found.  Also contains a few functions to write output  ***/
/***  after search.                                               ***/
/********************************************************************/

/***  Write saved trees to file  ***/

void write_species_tree(int node, int previous_node) {

  if (ppTwoRowS[0][node-(nspecies+1)]<=nspecies && ppTwoRowS[1][node-(nspecies+1)]<=nspecies) {

    //printf("(%d",ppTwoRowS[0][node-(nspecies+1)]);
    printf("(%s",speciesname[ppTwoRowS[0][node-(nspecies+1)]-1]);
    printf(":%f",fabs((-1.0)*(TimeVecS[ppTwoRowS[0][node-(nspecies+1)]]-TimeVecS[node])));
    //printf(",%d",ppTwoRowS[1][node-(nspecies+1)]);
    printf(",%s",speciesname[ppTwoRowS[1][node-(nspecies+1)]-1]);
    printf(":%f",fabs((-1.0)*(TimeVecS[ppTwoRowS[1][node-(nspecies+1)]]-TimeVecS[node])));
    printf(")");
    if (node != previous_node) {
      printf(":%f",fabs((-1.0)*(TimeVecS[node]-TimeVecS[previous_node])));
      }

  }

  if (ppTwoRowS[0][node-(nspecies+1)]<=nspecies && ppTwoRowS[1][node-(nspecies+1)]>nspecies) {

    //printf("(%d",ppTwoRowS[0][node-(nspecies+1)]);
    printf("(%s",speciesname[ppTwoRowS[0][node-(nspecies+1)]-1]);
    printf(":%f",fabs((-1.0)*(TimeVecS[ppTwoRowS[0][node-(nspecies+1)]]-TimeVecS[node])));
    printf(",");
    write_species_tree(ppTwoRowS[1][node-(nspecies+1)],node);
    printf(")");
    if (node != previous_node) {
      printf(":%f",fabs((-1.0)*(TimeVecS[node]-TimeVecS[previous_node])));
      }

  }

  if (ppTwoRowS[0][node-(nspecies+1)]>nspecies && ppTwoRowS[1][node-(nspecies+1)]<=nspecies) {

    //printf("(%d",ppTwoRowS[1][node-(nspecies+1)]);
    printf("(%s",speciesname[ppTwoRowS[1][node-(nspecies+1)]-1]);
    printf(":%f",fabs((-1.0)*(TimeVecS[ppTwoRowS[1][node-(nspecies+1)]]-TimeVecS[node])));
    printf(",");
    write_species_tree(ppTwoRowS[0][node-(nspecies+1)],node);
    printf(")");
    if (node != previous_node) {
      printf(":%f",fabs((-1.0)*(TimeVecS[node]-TimeVecS[previous_node])));
      }

  }

  if (ppTwoRowS[0][node-(nspecies+1)]>nspecies && ppTwoRowS[1][node-(nspecies+1)]>nspecies) {

    printf("(");
    write_species_tree(ppTwoRowS[0][node-(nspecies+1)],node);
    printf(",");
    write_species_tree(ppTwoRowS[1][node-(nspecies+1)],node);
    printf(")");
    if (node != previous_node) {
      printf(":%f",fabs((-1.0)*(TimeVecS[node]-TimeVecS[previous_node])));
      }

  }

}


void write_tree_root_saved(int node, int previous_node, Link pnode, FILE *res) {

  if ((pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]<=nspecies) && (pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]<=nspecies)) {
    fprintf(res,"(%s",speciesname[pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]-1]);
    fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]]-ppTimeVecS[pnode->loc_ppTR][node])));
    fprintf(res,",%s",speciesname[pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]-1]);
    fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]]-ppTimeVecS[pnode->loc_ppTR][node])));
    fprintf(res,")");
    if (node != previous_node) {
      fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][node]-ppTimeVecS[pnode->loc_ppTR][previous_node])));
      }

  }

  if (pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]<=nspecies && pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]>nspecies) {
    fprintf(res,"(%s",speciesname[pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]-1]);
    fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]]-ppTimeVecS[pnode->loc_ppTR][node])));
    fprintf(res,",");
    write_tree_root_saved(pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)],node,pnode,res);
    fprintf(res,")");
    if (node != previous_node) {
      fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][node]-ppTimeVecS[pnode->loc_ppTR][previous_node])));
      }

  }

  if (pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]>nspecies && pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]<=nspecies) {
    fprintf(res,"(%s",speciesname[pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]-1]);
    fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]]-ppTimeVecS[pnode->loc_ppTR][node])));
    fprintf(res,",");
    write_tree_root_saved(pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)],node,pnode,res);
    fprintf(res,")");
    if (node != previous_node) {
      fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][node]-ppTimeVecS[pnode->loc_ppTR][previous_node])));
      }

  }

  if (pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)]>nspecies && pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)]>nspecies) {
    fprintf(res,"(");
    write_tree_root_saved(pppTRS[pnode->loc_ppTR][0][node-(nspecies+1)],node,pnode,res);
    fprintf(res,",");
    write_tree_root_saved(pppTRS[pnode->loc_ppTR][1][node-(nspecies+1)],node,pnode,res);
    fprintf(res,")");
    if (node != previous_node) {
      fprintf(res,":%f",fabs((-1.0)*(ppTimeVecS[pnode->loc_ppTR][node]-ppTimeVecS[pnode->loc_ppTR][previous_node])));
      }

  }

}


/***  Write saved trees to file  ***/

void write_tree_root_saved_nolens(int node, int previous_node, Link pnode, FILE *res) {

  if (pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)]<=ntaxa && pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)]<=ntaxa) {

    fprintf(res,"(%d",pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)]);
    fprintf(res,",%d",pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)]);
    fprintf(res,")");

  }

  if (pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)]<=ntaxa && pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)]>ntaxa) {

    fprintf(res,"(%d",pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)]);
    fprintf(res,",");
    write_tree_root_saved_nolens(pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)],node,pnode,res);
    fprintf(res,")");

  }

  if (pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)]>ntaxa && pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)]<=ntaxa) {

    fprintf(res,"(%d",pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)]);
    fprintf(res,",");
    write_tree_root_saved_nolens(pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)],node,pnode,res);
    fprintf(res,")");

  }

  if (pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)]>ntaxa && pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)]>ntaxa) {

    fprintf(res,"(");
    write_tree_root_saved_nolens(pppTRS[pnode->loc_ppTR][0][node-(ntaxa+1)],node,pnode,res);
    fprintf(res,",");
    write_tree_root_saved_nolens(pppTRS[pnode->loc_ppTR][1][node-(ntaxa+1)],node,pnode,res);
    fprintf(res,")");

  }

}

void write_tree_root_place(int node, int previous_node, int place, FILE *res) {

  if (pppTRS[place][0][node-(ntaxa+1)]<=ntaxa && pppTRS[place][1][node-(ntaxa+1)]<=ntaxa) {

    printf("(%d",pppTRS[place][0][node-(ntaxa+1)]);
    printf(",%d",pppTRS[place][1][node-(ntaxa+1)]);
    printf(")");

  }

  if (pppTRS[place][0][node-(ntaxa+1)]<=ntaxa && pppTRS[place][1][node-(ntaxa+1)]>ntaxa) {

    printf("(%d",pppTRS[place][0][node-(ntaxa+1)]);
    printf(",");
    write_tree_root_place(pppTRS[place][1][node-(ntaxa+1)],node,place,res);
    printf(")");

  }

  if (pppTRS[place][0][node-(ntaxa+1)]>ntaxa && pppTRS[place][1][node-(ntaxa+1)]<=ntaxa) {

    printf("(%d",pppTRS[place][1][node-(ntaxa+1)]);
    printf(",");
    write_tree_root_place(pppTRS[place][0][node-(ntaxa+1)],node,place,res);
    printf(")");

  }

  if (pppTRS[place][0][node-(ntaxa+1)]>ntaxa && pppTRS[place][1][node-(ntaxa+1)]>ntaxa) {

    printf("(");
    write_tree_root_place(pppTRS[place][0][node-(ntaxa+1)],node,place,res);
    printf(",");
    write_tree_root_place(pppTRS[place][1][node-(ntaxa+1)],node,place,res);
    printf(")");

  }
}





/***  Free memory after added a node  ***/

void FreeNode(Link n) {

  free(n->iTree);
  free(n);

}




/***  Find tree with smallest likelihood in the current      ***/
/***  list of num_saved_trees trees and delete if from list  ***/

int DeleteMin() {

  int location;
  Link curr_min, prev_min;
  struct Node dummy_min;
  double mini_lik=0.0;

  dummy_min.Next = Head;
  prev_min = &dummy_min;
  curr_min = Head;
  
  /* find tree with minimum likelihood */

  for (;; prev_min=curr_min, curr_min=curr_min->Next) {

    if (curr_min == NULL) break;
    if (curr_min->max_lik < mini_lik) mini_lik = curr_min->max_lik;

  }

  /* loop again, but stop when you find min */

  for (prev_min = NULL, curr_min = Head;  
       curr_min != NULL && curr_min->max_lik != mini_lik;  
       prev_min = curr_min, curr_min = curr_min->Next);

  /* delete tree with minimum likelihood */

  location = curr_min->loc_ppTR;
  if (prev_min != NULL) prev_min->Next = curr_min->Next;
  else  Head = curr_min->Next;
 
  FreeNode(curr_min);
  NodeCount = NodeCount-1;
  if (first_annealing_pass==0) NodeCount2 = NodeCount2-1;

  return location;

}


/***  Add a tree to the linked list of trees that have been  ***/
/***  accepted                                               ***/

Link AddNodeAscend(Link to_add, double new_lik, FILE *res) {

  Link pn, prev, curr;
  struct Node dummy;
  int i, s;
  int tree_loc, tree_loc2;


  pn = (Link)malloc(sizeof(struct Node));
  if (pn == NULL)
    return 0;
  memcpy(pn,to_add,sizeof(struct Node));

  if (NodeCount>num_saved_trees) tree_loc = DeleteMin();
  else tree_loc = NodeCount;

  if (use_last) tree_loc = last_delete;

  dummy.Next = Head;
  prev = &dummy;
  curr = Head;

  for (;; prev=curr, curr=curr->Next) {

    if (curr == NULL) break;
    i = strcmp(pn->iTree,curr->iTree);
    if (i<=0) break; /* prev should go before curr */

  }

  if (curr && i==0) { /* new tree is the same as one on the list */

    if (NodeCount+1>num_saved_trees) {

      use_last = 1;
      last_delete = tree_loc;

    }

    tree_loc2 = curr->loc_ppTR;
    for (s=0; s<nspecies+1; s++) {

      pppTRS[tree_loc2][0][s] = ppTwoRowS[0][s];
      pppTRS[tree_loc2][1][s] = ppTwoRowS[1][s];
      ppTimeVecS[tree_loc2][s+1] = TimeVecS[s+1];
      ppTimeVecS[tree_loc2][s+nspecies] = TimeVecS[s+nspecies];
    
      }
    
    curr->times_hit++;
    if (curr->times_hit < bound_un) no_last_un = 1;
      
    FreeNode(pn);
    return curr;

  }

  /* otherwise add the new tree to the list */

  if (NodeCount+1>num_saved_trees) use_last=0;

   no_last_un=1;

  pn->first_hit = counteri;
  pn->max_lik = new_lik;
  pn->times_hit=1;
  pn->first_anneal = first_annealing_pass;
  pn->loc_ppTR = tree_loc;

  for (s=0; s<nspecies+1; s++) {

    pppTRS[tree_loc][0][s] = ppTwoRowS[0][s];
    pppTRS[tree_loc][1][s] = ppTwoRowS[1][s];
    ppTimeVecS[tree_loc][s+1] = TimeVecS[s+1];
    ppTimeVecS[tree_loc][s+nspecies] = TimeVecS[s+nspecies];

  }

  prev->Next = pn;
  pn->Next=curr;

  NodeCount++;
  Head = dummy.Next;
  return pn;

}





/***  Create a new linked list  ***/

void CreateList(void) {

  Head = NULL;
  NodeCount = 0;

}





void PrintTiedTrees(FILE *resu) {

  Link pn;
  int i;
  int counter=0, place;
  double best_lik=-99999.0;
  pn = Head;
  FILE *treefile;

  treefile = fopen("treefile.phy","w");

  fprintf(resu,">> The %d trees with the best likelihoods were:\n\n\n",NodeCount);

  /* Find best tree to write it first to treefile.phy */
  for (i=0; i<NodeCount; i++) {
    if (pn->max_lik>best_lik) {
      place = pn->loc_ppTR;
      best_lik = pn->max_lik;
    }
    pn = pn->Next;
  }

  pn = Head;
  for (i=0; i<NodeCount; i++) {
    if (pn->max_lik == best_lik) break;
    pn = pn->Next;
  }

  fprintf(treefile,"%f\t",-1.0*best_lik);
  write_tree_root_saved(nspecies+1,nspecies+1,pn,treefile);
  fprintf(treefile,";\n");

  pn = Head;

  for (i=0; i<NodeCount; i++) {
    
    if (pn->max_lik>best_lik) {
      place = pn->loc_ppTR;
      best_lik = pn->max_lik;
    }
    
    /* Now print tree info and tree */
    
    fprintf(resu,"Tree Number %d\n\n",i+1);
    fprintf(resu,"First visited at iteration:  %d\n",pn->first_hit);
    fprintf(resu,"Max ln L for tree:  %f\n",pn->max_lik);
    fprintf(resu,"Number of times visited:  %d\n",pn->times_hit);
    fflush(0);
    
    fprintf(treefile,"%f \t",-1.0*(pn->max_lik));
    write_tree_root_saved(nspecies+1,nspecies+1,pn,treefile);
    fprintf(treefile,";\n");
    
    write_tree_root_saved(nspecies+1,nspecies+1,pn,resu);
    fprintf(resu,";\n");
    /*     write_tree_root_saved_nolens(nspecies+1,nspecies+1,pn,res);
	   fprintf(res,";\n\n");
    */
    /*   for (j=1; j<ntaxa+1; j++) {	  
	 for (k=j+1; k<ntaxa+1; k++) {
	 fprintf(res,"%d",pn->iTree[counter]-48);
	 fprintf(res,"%d",pn->iTree[counter+1]-48);
	 fprintf(res,"%d ",pn->iTree[counter+2]-48);
	 counter = counter+3;
	 }
	 fprintf(res,"\n");
	 }*/
    
    counter=0;
    
    fprintf(resu,"\n\n");
    
    pn = pn->Next;
    
  }
  
  /*printf("best tree is %f, stored in %d\n",best_lik,place);*/
  
  /*printf("\n   The ML tree is ");
    write_tree_root_place(nspecies+1,nspecies+1,place,res);
    printf(" with log likelihood %f. See the file 'results' for complete information.\n\n",best_lik);
  */
  fprintf(resu,">> The ML tree has log likelihood %f.\n",best_lik);
  fprintf(resu,"\n\n");
  
  fclose(treefile);
  
}


/***  Reduce the linked list to the k best trees  ***/
/***  after it had been expanded to the 2k best   ***/

void FindBest() {

  while (NodeCount>num_saved_trees/2) DeleteMin();
  num_saved_trees = num_saved_trees/2;

}



/***  Function to search through ppTwoRow_temp to find parent ***/
/***  of a specified node.                                    ***/

int find_parent_temp(int target) {

int i, j, parent=0;

 for (j=0; j<2; j++) {
   for (i=0; i<nspecies; i++) {
     if (ppTwoRowS[j][i]==target) {
      parent = i+nspecies+1;
      break;
     }
   }
 }

 if (parent==0) { printf("Could not find parent in find_parent_temp for target = %d\n",target); }
return(parent);

}





/***  Function to find the generation of the input node   ***/

int find_gen(int current_node) {

  int gen_counter=0, parent;

    parent = current_node;

    while (parent != nspecies+1) {

      parent = find_parent_temp(parent);
      gen_counter++;

    }

    return gen_counter;

}




/***  Function to construct the IND matrix  ***/

void make_indmat() {

  int q, r;
  int parent1, parent2, check=0;
  int dist1=0, dist2=1;

  for (q=1; q<nspecies+1; q++) {

    for (r=q+1; r<nspecies+1; r++) {

      parent1 = find_parent_temp(q);
      parent2 = find_parent_temp(r);

      while (parent1 != nspecies+1 && check != 1) {

	while (parent2 != nspecies+1 && check != 1) {

	  if (parent1 == parent2) {

	    check = 1;
	    break;

	  }

	  parent2 = find_parent_temp(parent2);
	  if (check != 1) dist2++;

	}

	if (check == 1) break;

	else {

	  parent1 = find_parent_temp(parent1);
	  dist1++;
	  dist2 = 1;
	  parent2 = find_parent_temp(r);
	  
	}

      }

      ppMatrix[q][r] = dist1 + dist2;

      if ((parent1 == nspecies+1 || parent2 == nspecies+1) && check == 0) {

	ppMatrix[q][r] = find_gen(q) + find_gen(r) - 1;
	check = 1;

      }
 
      check = 0;
      dist1 = 0;
      dist2 = 1;

    }

    check = 0;
    dist1 = 0;
    dist2 = 1;


  }

}




/***  Convert IND matrix to a number representing the tree.  This   ***/
/***  number is a unique representation of the tree and is used to  ***/
/***  compare trees                                                 ***/

char *make_matnum(int **ppMatrix1) {

  int q, r, temp;
  int counter=0;
  char *aa;

  aa = (char*)malloc(((nspecies*(nspecies-1)/2)*3+1)*sizeof(char));
  if (aa==NULL) {
    printf("can't memalloc aa\n");
    exit(1);
  }

  for (q=1; q<nspecies+1; q++) {

    for (r=q+1; r<nspecies+1; r++) {

      aa[counter] = (char)((ppMatrix1[q][r]/100)+48);
      temp = ppMatrix1[q][r]%100;
      aa[counter+1] = (char)(temp/100+48);
      aa[counter+2] = (char)((temp%100)+48);

      counter = counter + 3;

    }

  }

  aa[counter] = '\0';

  return aa;

}










